%{
  #include "../common_file/any2tfb.h"
  Symbol *make_duplicate_poly(int);
%}

%union{   /* type of yylval */
  int narg;   /* number of args */
  Symbol *sym; /* pointer to symbol */
}

/*
  Asir$B$G$O(B
  $BBgJ8;z$+$i;O$^$k1Q?t;zNs(B->$BJQ?t(B   $B%W%m%0%i%_%s%0$G$NJQ?t$N$3$H(B
  $B>.J8;z$+$i;O$^$k1Q?t;zNs(B->$BITDj85(B $BB?9`<0$NJQ?t$N$3$H(B
*/

%start list    /* $B%G%U%)%k%H$G$O(B1$BHV>e$N5,B'$+$i;O$^$k$N$G$3$l$O$J$/$F$b$h$$(B */
%token<sym> NUMBER VAR HUTEIGEN STRING /*HUTEIGEN:$BITDj85!J?t3X$G$NJQ?t(B)*/  
%token<sym> FUNCTION PREVIOUS CONST /* VAR:$B%W%m%0%i%_%s%0$G$NJQ?t(B */
%token<sym> MODULE /* $B%b%8%e!<%k4X?t(B mymodule.f */
%token PARENS LIST OPE ASSIGN      /* $B>.3g8L$HBg3g8L$H1i;;;R$HBeF~1i;;;R(B */
%token DP /* $BJ,;6I=8=B?9`<0(B:$BMW$O<!?t$r<h$j=P$7$?%j%9%H$N$h$&$J$b$N(B */
%token RANGE   /* $BHO0O(B */
%token ELEMENT            /* $BMWAGCj=P$N:]$NJQ?t(B  */
%token FUNCTIONELEMENT    /* $B4X?t8F$S=P$7$N$"$H$KMWAGHV9f$,$D$$$?>l9g(B */
%type<sym> expr asgn
%type<narg> datalist index end


%right '='
%left EQ    /* ==$B$N$3$H(B */
%left '+' '-'
%left '*' '/'
%left '%'
%left UNARYMINUS UNARYPLUS   /* $BC19`%^%$%J%9(B,$B%W%i%9(B */
%right '^'
%%

list:   /* nothing */
| list end
| list expr end  {print_expr(); printend($3);}
| list asgn end  {print_expr(); printend($3);}
| list error end {yyerrok;}
;

end: ';' {$$=0;}
| '$'    {$$=1;}
;

/***************
NUMBER:$B?t;z(B
VAR:$BJQ?t(B
HUTEIGEN:$BITDj85(B
STRING:$BJ8;zNs(B
CONST:$BDj?t(B
PREVIOUS:$BA02s$NEz$((B
$B$A$J$_$K(B{$$=$1;}$B$O%G%U%)%k%H%"%/%7%g%s$J$N$G>JN,2DG=(B
HUTEIGEN '(' datalist ')' ->$B4X?t8F$S=P$7(B
HUTEIGEN '(' datalist ')' index ->$B<B8=$-$D$=$&(B
***************/

expr: NUMBER {push($1); $$=$1;} 
| VAR        {push($1); $$=$1;}
| HUTEIGEN   {push($1); $$=$1;}
| STRING     {push($1); $$=$1;}
| CONST      {push($1); $$=$1;} 
| PREVIOUS   {push($1); $$=$1;} 
| HUTEIGEN '(' datalist ')' {$1->type=FUNCTION;$$=makefunc($1,$3);}
| HUTEIGEN '(' datalist ')' index {$1->type=FUNCTION;$$=makefunc_elem($1,$3,$5);}
| MODULE '(' datalist ')' {$$=makefunc($1,$3);}
| '(' expr ')' {$$=kakko();}
| '<' '<' datalist '>' '>' {$$=make_duplicate_poly($3);} /* $BJ,;6I=8=B?9`<0(B: */
| expr '+' expr {$$=add();}  /*$BB?9`<0$N<!?t$@$1$r<h$j=P$7$?%j%9%H$N$h$&$J$b$N(B*/
| expr '-' expr {$$=sub();}
| expr '*' expr {$$=mul();}
| expr '/' expr {$$=divide();}
| expr '^' expr {$$=power();}
| expr '%' expr {$$=mod("%");}
| expr EQ expr {$$=make_eq();}
| '-' expr   %prec UNARYMINUS {$$=unaryminus();} 
| '+' expr   %prec UNARYPLUS  {$$=unaryplus();}
| '[' datalist ']' {$$=makelist($2);}  /* list or vector */ 
| VAR index {$1->type=ELEMENT;$$=make_element($1,$2);} /* $BMWAG$N<h$j=P$7(B */
;


index: '[' expr ']'  {$$=1;} /* $BE:;z72(B */
| index '[' expr ']' {$$=$1+1;}  /* [1][2]$B$J$I$N9MN8(B */
;


asgn: VAR '=' expr  {$$=assignment($1);}   /* $BJQ?t$X$NBeF~(B */
| VAR index '=' expr {$1->type=ELEMENT;$$=element_assign($1,$2,$4);} 
                   /* $BMWAG$X$NBeF~(B*/
| HUTEIGEN '(' datalist ')' index '=' expr  /* $B$-$D$$$+$J!#!#(B */
                     {$1->type=FUNCTION;$$=func_elem_assign($1,$3,$5,$7);}
;


/* $B0z?t$d%j%9%H$J$I$G$N%G!<%?$N%j%9%H(B */
datalist:  {$$=0;}  /* nothing */ 
| expr     {$$=1;}   
| datalist ',' expr {$$=$1+1;} 
;
%%
/* end of grammer */


#include<stdio.h>
#include<stdlib.h>
#include<ctype.h>
#include<setjmp.h>
#include<string.h>
char *progname;
int lineno=1;    /* for error message */
jmp_buf begin;
int skip(void);   /* $B6uGr2~9T$OHt$P$7$F<!$N(B1$BJ8;z$rFI$_9~$`(B */
int commentskip(void);  /* $B%3%a%s%H$rFI$_$H$P$9(B */
int follow(int,int,int);    /* 2$BJ8;z$+$i$J$k%H!<%/%s$N2DG=@-$rD4$Y$k(B */
static unsigned int buffersize=0x100000; /* $B%P%C%U%!%5%$%:(B:default 1Mbyte:1048576$B7e(B $B:GBg$G(B4294967295$B7e(B */
short src=ASIR;  /* $B$I$N%=%U%H$+$i$NJQ49$+(B */

main(int argc,char *argv[])
{
  int i;
  for(i=1;i<argc;i++){
	if(strcmp("--buffersize",argv[i])==0)
	  buffersize=atoi(argv[i+1]);   /* default$BCM$NJQ99(B */
  }

  progname=argv[0];
  setjmp(begin);
  yyparse();
}


/***************************
NUMBER:$B?t;z(B -> value$B$K$O?t;zNs(B
VAR:$BJQ?t(B    -> value$B$K$OJQ?tL>(B
HUTEIGEN:$BITDj85(B -> value$B$K$OITDj85L>(B
STRING:$BJ8;zNs(B   -> value$B$K$O%@%V%k%/%*!<%H(B"$B$r=|$$$?J8;zNs(B
CONST:$BDj?t(B      -> value$B$K$O(B@$B$r=|$$$?J8;zNs(B
PREVIOUS:$BA02s$NEz$((B -> value$B$K$O(B"@@"
***************************/

int yylex(void)
{
  int c;
  char *value; /*$B;CDjE*$K?t;zNs$dJQ?t$NL>A0$J$I$rF~$l$kNN0h(B*/
  char *p;
  value=(char *)malloc(buffersize);
  p=value;
  c=skip();     /* $B%3%a%s%H2~9T6uGr%?%V$O$H$P$7(B */
  /* printf("%c\n",c);     $B%G%P%C%0(B */
  if(c==EOF){
	free(value);
	return 0;
  }
  if(myisdigit(c)){     /* NUMBER */
	do{
	  *p++=c;
	  if(p>=value+buffersize-1){
		*p='\0';
		execerror("number too big , please use --buffersize option.",(char *)0);
	  }
	}while((c=getchar())!=EOF && myisdigit(c));
	if(c!='.'){         /* $B>.?t$G$J$$(B */
	  *p='\0';
	  ungetc(c,stdin);
	  yylval.sym=makesymbol(NUMBER,value);
	  free(value);
	  return NUMBER;
	}
	do{                 /* $B>.?tE@0J2<$N%3%T!<(B */
	  *p++=c;
	  if(p>=value+buffersize-1){
		*p='\0';
		execerror("number too big , please use --buffersize option.",value);
	  }
	}while((c=getchar())!=EOF && myisdigit(c));
	*p='\0';
	ungetc(c,stdin);
	yylval.sym=makesymbol(NUMBER,value);
	free(value);
	return NUMBER;
  }

  if(myisupper(c)){    /* $BBgJ8;z$+$i;O$^$kJQ?t(B */
	do{
	  *p++=c;
	  if(p>=value+buffersize-1){
		*p='\0';
		execerror("number too big , please use --buffersize option.",value);
	  }
	}while((c=getchar())!=EOF && (myisalnum(c) || c=='_'));
	*p='\0';
	ungetc(c,stdin);
	yylval.sym=makesymbol(VAR,value);
	free(value);
	return VAR;
  }
  if(myislower(c)){    /* $B>.J8;z$+$i;O$^$kITDj85(B  */
	do{
	  *p++=c;
	}while((c=getchar())!=EOF && (myisalnum(c) || c=='_'));
	if(c=='.'){  /* $B%b%8%e!<%k4X?t$N7A(B:mymodule.f */
	  do{
		*p++=c;
		if(p>=value+buffersize-1){
		  *p='\0';
		  execerror("number too big , please use --buffersize option.",value);
		}
	  }while((c=getchar())!=EOF && (myisalnum(c) || c=='_'));
	  ungetc(c,stdin);
	  *p='\0';
	  yylval.sym=makesymbol(MODULE,value);
	  free(value);
	  return MODULE;
	}
	*p='\0';
	ungetc(c,stdin);
	yylval.sym=makesymbol(HUTEIGEN,value);
	free(value);
	return HUTEIGEN;
  }
  if(c=='"'){
	for(;(c=getchar())!='"';p++){
	  if(c=='\n' || c==EOF){
		execerror("missing quote","");
	  }
	  if(p>=value+buffersize-1){
		*p='\0';
		execerror("string too long , please use --buffersize option.",value);
	  }
	  *p=c;
	}
	*p='\0';
	yylval.sym=makesymbol(STRING,value);
	free(value);
	return STRING;
  }
  if(c=='@'){    /* @@$B$OD>A0$NEz$((B,@pi$B$ODj?t(B */
	if((c=getchar())=='@'){
	  yylval.sym=makesymbol(PREVIOUS,"@@");
	  free(value);
	  return PREVIOUS;
	}
	if(myisalpha(c)){
	  do{   /* @$B$N8e$K%"%k%U%!%Y%C%H$,B3$1$PDj?t(B */
		*p++=c;            /* $BB3$+$J$1$l$P(B@$B$N$_$N%H!<%/%s(B */
		if(p>=value+buffersize-1){
		*p='\0';
		execerror("number too big , please use --buffersize option.",value);
		}
	  }while((c=getchar())!=EOF && myisalpha(c));
	  *p='\0';
	  /* printf("%s\n",value); for debug  */   
	  ungetc(c,stdin);
	  yylval.sym=makesymbol(CONST,value);
	  free(value);
	  return CONST;       /* $BDj?t(B  */
	}
	else{    /* @$B$N$_(B */
	  ungetc(c,stdin);
	  free(value);
	  return '@';
	}
  }
  free(value);
  return c;    /* default */
}  


int yyerror(char *s) /* call from yyparse when syntax error exists */
{
  warning(s,(char *)0);
}


int warning(char *s,char *t)
{
  fprintf(stderr,"%s: %s",progname,s);
  if(t!=0)
	fprintf(stderr,"%s",t);
  fprintf(stderr," near line %d\n",lineno);
}


void execerror(char *s,char *t)
{
  warning(s,t);
  init();
  longjmp(begin,0);
}


int skip()
{
  int c;   
  int c1;   /* $B0lJ8;z@h$^$GFI$`$H$-(B */
  for((c=getchar()) ; ; ){
	switch(c){               
	case ' ': case '\t':  /* $B6uGr$OFI$_$H$P$7(B */
	  c=getchar(); 
	  break;
	case '\n':
	  lineno++;
	  c=getchar();
	  break;
	case '/':             /* / $B$,$-$?(B->$B$5$i$K!v$,$-$?(B->$B%3%a%s%H(B */
	  if((c1=getchar())=='*')
		c=commentskip();    /* $B%3%a%s%H$rFI$_$H$P$7(B */
	  else{
		ungetc(c1,stdin);  /* /$B$N<!$,!v0J30(B->$B3d$j;;1i;;;R(B / $B$HH=Dj(B */
		return c;
	  }
	  break;
	case '=':   return follow('=',EQ,'=');
	default:
	  return c;
	  break;
	}
  }  
}


int commentskip()
{
  int c;
  int c1;
  for((c=getchar()); ; ){
	c1=getchar();    /* $B<!$NJ8;z$rFI$^$;$k(B */
	if(c1=='\n')    /* $B2~9T$r%+%&%s%H(B */
	  lineno++;
	if((c=='*' && c1=='/'))    /* '*'$B$H(B'/'$B$,O"B3$G$-$?(B->$B%3%a%s%H$N=*$j(B */
	  return getchar();       /* $B$5$i$K<!$NJ8;z$rJV$9(B  */
	else
	  c=c1;                    /* c$B$r(Bc1$B$KDI$$$D$+$;$k(B */
  }
}


int follow(int expect,int ifyes,int ifno)  /* look ahead for == etc.. */
{
  int c;
  c=getchar();
  if(c==expect)
	return ifyes;
  else{
	ungetc(c,stdin);
	return ifno;
  }
}


/* asir$B$@$1$N9=J8LZ:n@.4X?t72(B*/
Symbol *make_duplicate_poly(int number)
{
  Symbol *dp=makesymbol(DP,NULL);
  appendchildren1(dp,number);
  push(dp);
}

