typedef struct Symbol{
  short type;      /* NUMBER VAR HUTEIGEN STRING UNARYMINUS */
  char *value;    /* value or VAR name or FUNC name..  */
  int number;     /* number of children */
  struct Symbol **childp;  /* pointer to children */
}Symbol;


/*
  isdigit,isalnum$BEy$O(B-1$B$+$i(B255$B0J30$N?t;z$G$OF0$+$J$$$N$G:n@.(B
  (symbol.c)$B$K:n@.(B
*/
extern int myisdigit(int);   /*  number */
extern int myisupper(int);    /* upper */
extern int myislower(int);   /* lower */
extern int myisalnum(int);  /* alphabet or number */
extern int myisalpha(int);  /* alphabet */



extern Symbol *makesymbol(short,char *);
extern void execerror(char *,char *);
extern void init(void);
extern void push(Symbol *);
extern Symbol *pop(void);
extern Symbol *pop_i(int);
/* $B9=J8LZ:n@.4X?t72(B */
extern void appendchildren1(Symbol *,int);    /* $B5U=g;R6!IU$1(B */
extern void appendchildren2(Symbol *,int);    /* $BAGD>$K;R6!IU$1(B */
extern Symbol *add(void);
extern Symbol *sub(void);
extern Symbol *mul(void);
extern Symbol *divide(void);
extern Symbol *power(void);
extern Symbol *mod(char *);
extern Symbol *unaryminus(void);
extern Symbol *unaryplus(void);
extern Symbol *assignment(Symbol *);
extern Symbol *kakko(void);
extern Symbol *make_eq();
extern Symbol *makefunc(Symbol *,int);
extern Symbol *makefunc_elem(Symbol *,int,int);
extern Symbol *makelist(int);
extern Symbol *make_element(Symbol *,int);
extern Symbol *element_assign(Symbol *,int,Symbol *);
extern Symbol *func_elem_assign(Symbol *,int,int,Symbol *);

/* $B9=J8LZI=<(4X?t72(B  */
extern void print_expr(void);
extern void treeprint(Symbol *);
extern void printend(int);
extern void check_type(Symbol *,int,int);


/* $BITDj85%j%9%H4X?t72(B(symbol.c)   */
extern int lookup(char *);      /* $BITDj858!:w(B $B$"$C$?$i#1!"$J$+$C$?$i#0(B*/
extern void install(char *);    /* $B?7$?$JITDj85$N%j%9%H$X$NEPO?(B */
extern void var_remove(char *); /* $B%j%9%H$+$i$N:o=|(B&type$B$N(BHUTEIGEN$B$X$NJQ49(B */


/* $B9=J8LZJQ494X?t72(B */
extern void list_to_range(Symbol *);   /* $BHO0O%j%9%H$r(BRANGE$B$K(B */
extern void insert_follow_down(Symbol *,Symbol *,int); 
/* $BLZ$X$NA^F~(B($B>\$7$/$O(Btfb2any/common_file/transform.c$B$K(B) */



#define CHILD 5    /* $BLZ9=B$$K$*$$$F=i4|>uBV$G;}$F$k;R6!$N?t(B */

extern short src;  /* $B$I$N%=%U%H$+$i$NJQ49$+(B */
#define ASIR 0
#define MATH 1
#define MAPLE 2
#define MATLAB 3
