#include "../common_file/any2tfb.h"
#include "../common_file/y.tab.h"
#include<stdio.h>
#include<ctype.h>
#include<stdlib.h>
void head_change_to_lower(Symbol *);  /* $B@hF,$N;z$r>.J8;z$KJQ49(B */
void module_print(char *);  /* module$B$NI=<((B.(`$B$,$-$?$iBe$o$j$K(B.$B$rI=<((B) */

/******************

$B$3$3$+$i9=J8LZ$NI=<((B
check_type$B$NBh#30z?t$O(Bmath2tfb$B$G$O0UL#$r$b$?$J$$(B

*******************/


void printend(int flag)
{
  if(flag==0)
	printf(";\n");
  else
	printf("$\n");
}


void print_expr()
{
  Symbol *sp=pop();
  transform(sp); /*$B%N!<%I$NJQ49(B*/
  treeprint(sp);
  free(sp);
}


void treeprint(Symbol *sp)
{
  int i;
  if(sp->number==0){     /* $B;R6!$,(B1$B?M$b$$$J$$$H$-$O$=$l$r0u;z(B */
	check_type(sp,1,0);
	if(sp->type==LIST || sp->type==FUNCTION || sp->type==MODULE) /*$B%j%9%H$H4X?t$O(B */
	  check_type(sp,2,0);                   /* $B;R6!$,$$$J$/$F$bJD$83g8LI,MW(B */
	return ;
  }
  else{   /* $B;R6!$,$$$k$H$-$K$O;R6!$r0u;z(B($B:F5"!K(B */
	check_type(sp,1,0);         /* $B;R6!$r0u;z$9$kA0$K3g8L3+$-!)(B  */
	for(i=0;i<sp->number;i++){
	  treeprint(*((sp->childp)+i));  /* $B;R6!$KBP$7$FF1$8Av::(B */
	  if(i<sp->number-1)/*$B:G8e$N%3%s%^(B.$B$$$l$J$+$C$?$i:G8e$K%3%s%^$,#1$DM>J,(B*/
		check_type(sp,3,0);  /* $B%j%9%H$d4X?t$J$i;R6!$N4V$K%3%s%^$,F~$k(B */
	}
	check_type(sp,2,0);    /* $B;R6!$r0u;z$7$?$"$H3g8LJD$8!)(B */
  }
}


/*
  check_type
  $B%N!<%I$N<oN`$H#2$D$a$N0z?t!J%N!<%IAv::Cf$N(B $B@h(B:$B#1(B $BCf(B:$B#3(B $B8e(B:$B#2(B $B$N$I$l$+!K(B
  $B$K$h$C$FI=<($r@Z$jBX$($k4X?t(B
*/
void check_type(Symbol *sp,int time,int childnum)
{
  switch(sp->type){
  case NUMBER:
  case PREVIOUS:
	if(time==1)
	  printf("%s",sp->value);
	break;

  case VAR:
	if(time==1){
	  if(isupper(sp->value[0])){      /* $BL>A0$N@hF,$,BgJ8;z$@$C$?$i(B */
		head_change_to_lower(sp);     /* $B@hF,$NJ8;z$r>.J8;z$K(B  */
	  }
 		printf("%s",sp->value);   
	}
	  break;
  case CONST:
	if(time==1)
	  printf("mathconst@%s",sp->value);
	break;
  case STRING:
	if(time==1)
	  printf("\"%s\"",sp->value);
	break;
	
  case FUNCTION:
	if(time==1)    /* $B@h(B */
	  printf("math@%s(",sp->value); 
	else if(time==2)   /* $B8e(B */
	  printf(")");
	else if(time==3)   /* $BCf(B */
	  printf(",");
	break;
	
  case MODULE:      /* mymodule`f$B$N7A$N4X?t(B($B%P%C%/%/%)!<%H(B) */
	if(time==1){    /* $B@h(B */
	  module_print(sp->value); /* $BMW$O(B`$B$,$-$?$i(B.$B$rI=<($9$k$@$1(B*/
	  printf("(");
	}
	else if(time==2)   /* $B8e(B */
	  printf(")");
	else if(time==3)   /* $BCf(B */
	  printf(",");
	break;	
	
	
  case PARENS:
	if(time==1)
	  printf("(");
	else if(time==2)
	  printf(")");
	break;
	
  case LIST:
	if(time==1)
	  printf("[");
	else if(time==2)
	  printf("]");
	else if(time==3)
	  printf(",");
	break;
	
  case UNARYMINUS:
  case UNARYPLUS:
	if(time==1)
	  printf("%s",sp->value);
	break;
	
  case ELEMENT:
	if(time==1){       /* $BBgJ8;z$J$i(B1$BJ8;zL\$r>.J8;z$KJQ49(B */
	  if(isupper(sp->value[0])){
		head_change_to_lower(sp);   /* $B>.J8;z$X(B */
	  }
		printf("%s[",sp->value);
	}
	else if(time==2)
	  printf("]");
	else if(time==3)
	  printf("][");
	break;

  case OPE:
	if(time==3)
	  printf("%s",sp->value);
	break;
  case ASSIGN:
	if(time==3)
	  printf("=");
	break;
  case RANGE:
	if(time==3)
	  printf("..");
	break;
  case EQ:
	if(time==3)
	  printf("==");
	break;
  }
}


void head_change_to_lower(Symbol *sp)   /* value$B$N(B1$BJ8;zL\$r>.J8;z$KJQ99(B */
{
  sp->value[0]+=0x20; /* $BJ8;z%3!<%II=$h$j(B0x20$BB-$;$PBgJ8;z"*>.J8;z$K$J$k(B */
}

void module_print(char *module)
{
  char *p=module;
  while(*p!='\0'){
	if(*p=='`')   /* $B%P%C%/%/%*!<%H(B->.$B$rI=<((B */
	  printf(".");
	else
	  printf("%c",*p);
	p++;
  }
}
