#include<stdio.h>
#include<string.h>
#include "tfb2any.h"
#include "y.tab.h"
#define SOFT 4
char *add_head(Symbol *,char *);
extern int lineno;

/*
  $BJQ49%F!<%V%k5Z$S%F!<%V%k8!:w4X?t(B
  $BG[Ns$O=i4|2=$7$F$J$$MWAG$K$O<+F0E*$K(B0$B$rBeF~$7$F$/$l$k(B
  $B4X?tL>JQ49%F!<%V%k(B($BJQ49%G!<%?%Y!<%9(B)
*/
static char *functiontable[100][SOFT]=
/* Asir           Mathematica       Maple     MATLAB  */
{
  {"Asir"     ,  "Mathematica"  , "Maple" ,  "MATLAB"},/*0$B9TL\$O%(%i!<I=<(MQ(B*/
  /* $B;03Q4X?t(B */
  {"sin"      ,  "Sin"          , "sin"   ,  "sin"},
  {"cos"      ,  "Cos"          , "cos"   ,  "cos"},
  {"tan"      ,  "Tan"          , "tan"   ,  "tan"},
  {"asin"      , "ArcSin"       , "arcsin" , "asin"},
  {"acos"      ,  "ArcCos"      , "arccos"   ,  "acos"},
  {"atan"      ,  "ArcTan"      , "arctan"   ,  "atan"},
  {"sinh"      ,  "Sinh"          , "sinh"   ,  "sinh"}, /* $BB>$K$b$?$/$5$s(B */

  {"abs"      ,  "Abs"             , "abs"   ,  "abs"}, /* $B@dBPCM(B */
  {"sqrt"      ,  "Sqrt"          , "sqrt"   ,  "sqrt"},  /* $B%k!<%H(B */
  {"exp"      ,  "Exp"          , "exp"   ,  "exp"},
  {"log"      ,  "Log"          , "log"   ,  "log"},
  {"nothing"  ,  "Integrate"    ,  "int"    , "quad"},   /* $B@QJ,(B */

  {"nothing" , "HypergeometricPFQ" , "hypergeom"  , "hypergeom"},/*$BD64v2?4X?t(B*/
  {"plot"     ,  "Plot"         , "plot"  ,  "plot"},
  {"quote"    ,  "erase"        , "erase" ,  "erase"},
  {"matrix_transpose" ,"Transpose" ,"linalg[transpose]","transpose"},/* $BE>CV(B */
  {"nothing"  ,  "ConjugateTranspose","nothing","ctranspose"}, /* $B6&LrE>CV(B */
  {"nothing"  ,  "Gamma"        ,  "GAMMA"     ,"gamma"},   /* gamma function*/
  {NULL       ,   NULL          ,  NULL     ,  NULL}
};




/*
  $BB3$$$FDj?tJQ49%F!<%V%k(B
*/
static char *consttable[20][SOFT]=
/* Asir         Mathematica      Maple       MATLAB */
{
  {"i"      ,  "I"          ,    "I"        ,  "i"},
  {"i"      ,  "I"          ,    "I"        ,  "j"},
  {"nothing",  "Infinity"   ,    "infinity" , "Inf"},
  {"nothing",  "Infinity"   ,    "infinity" , "inf"},
  {"pi"     ,  "Pi"         ,    "Pi"       , "pi"},
  {"nothing",  "Degree"     ,    "nothing"  , "nothing"},
  {"nothing",  "GoldenRatio", "nothing"     , "nothing"},  
  {"e"      ,  "E"          , "exp(1)"      , "exp(1)"},  
  {"nothing",  "EulerGamma" , "gamma"       , "nothing"},
  {"nothing",  "Catalan"    , "Catalan"     , "nothing"},
  {NULL     ,    NULL       ,  NULL         , NULL}
};












/*
      $B$3$3$h$j2<$O$a$C$?$J$3$H$G?($k$b$s$8$c$"$J$$(B
*/


/*
  function_searchtable
  $B4X?tL>JQ49%F!<%V%k$+$i4X?t$rC5$7!"JQ49$7$?$$L>A0$rJV$9(B
*/
char *function_searchtable(Symbol *sp)   /* sp->mode$B$r8+$l$P$I$N%=%U%H$N4X?t$+$o$+$k(B */
{                            /* target$B$O$I$N%=%U%H$KJQ49$7$?$$$+!"$H$$$&Dj?t(B */
  int i;
  char *tmp;
  for(i=1; ;i++){ /*0$BHV$O(Berror$BMQJ8;zNs(B.$B%F!<%V%k$+$i3:Ev$9$k%b!<%I$N4X?t$rC5$9(B*/
	if(functiontable[i][sp->mode]==NULL) /*$B%F!<%V%k$N=*$j$O#0F~$l$^$7$?(B*/
	  break;  /* for$BJ8$rH4$1$k(B */
	if(strcmp(sp->value,functiontable[i][sp->mode])==0){ /* $B4X?t$r8+$D$1$?$i(B */
	  if(strcmp(functiontable[i][target],"nothing")==0){ /* error */
		fprintf(stderr,"Warning: %s cannot be translated into the equivalent function in %s. It does not exist in %s. (near line %d)\n",sp->value,functiontable[0][target],functiontable[0][target],lineno);
		if(sp->mode==ASIR)  /* $B8+$D$+$i$J$+$C$?;~$NOC(B */
		  tmp=add_head(sp,"asir_");
		if(sp->mode==MATH)
		  tmp=add_head(sp,"math_");
		if(sp->mode==MAPLE)
		  tmp=add_head(sp,"maple_");
		if(sp->mode==MATLAB)
		  tmp=add_head(sp,"matlab_");
		return tmp;
	  }
	  return functiontable[i][target];       /* $BJQ49$7$?$$L>A0$rJV$9(B */
	}
  }
  if(sp->mode==ASIR)  /* $B8+$D$+$i$J$+$C$?;~$NOC(B */
	tmp=add_head(sp,"asir_");
  if(sp->mode==MATH)
	tmp=add_head(sp,"math_");
  if(sp->mode==MAPLE)
	tmp=add_head(sp,"maple_");
  if(sp->mode==MATLAB)
	tmp=add_head(sp,"matlab_");
  fprintf(stderr,"Warning: sorry, the function %s is not in the translation table.(near line %d)\n",sp->value,lineno);
  return tmp; 
}



/*
  const_searchtable
  $B>e$NDj?t%F!<%V%k%P!<%8%g%s(B
*/
char *const_searchtable(Symbol *sp)
{ 
  int i;
  char *tmp;
  for(i=0; ;i++){     /* $B%F!<%V%k$+$i3:Ev$9$k%b!<%I$N4X?t$rC5$7=P$9(B */
	if(consttable[i][sp->mode]==NULL) /*$B%F!<%V%k$N=*$j$O(BNULL$BF~$l$^$7$?(B*/
	  break;
	if(strcmp(sp->value,consttable[i][sp->mode])==0){ /* $B4X?t$r8+$D$1$?$i(B */
	  if(strcmp(consttable[i][target],"nothing")==0){
		fprintf(stderr,"Warning: %s cannot be translated into the equivalent constant in %s. It does not exist in %s.(near line %d)\n",sp->value,functiontable[0][target],functiontable[0][target],lineno);
		if(sp->mode==ASIR)  /* $BBP1~$9$kDj?t$,L5$$$H$-(B */
		  tmp=add_head(sp,"asirconst_");
		if(sp->mode==MATH)
		  tmp=add_head(sp,"mathconst_");
		if(sp->mode==MAPLE)
		  tmp=add_head(sp,"mapleconst_");
		if(sp->mode==MATLAB)
		  tmp=add_head(sp,"matlabconst_");
		return tmp;
	  }
	  return consttable[i][target];       /* $BJQ49$7$?$$L>A0$rJV$9(B */
	}
  } 
  if(sp->mode==ASIR)  /* $B8+$D$+$i$J$+$C$?;~$NOC(B */
	tmp=add_head(sp,"asirconst_");
  if(sp->mode==MATH)
	tmp=add_head(sp,"mathconst_");
  if(sp->mode==MAPLE)
	tmp=add_head(sp,"mapleconst_");
  if(sp->mode==MATLAB)
	tmp=add_head(sp,"matlabconst_");
  fprintf(stderr,"Warning: sorry, the constant %s is not in the translation table.(near line %d)\n",sp->value,lineno);
  return tmp;   
}


/*value$B$N@hF,$K0z?t$NJ8;zNs$rDI2C$b$N$rJV$9(B*/
char *add_head(Symbol *sp,char *string)
{
  char *tmp;
  int i=strlen(string);
  /* +i for append string */
  tmp=(char *)emalloc(strlen(sp->value)+i+1); /* +1 for '\0' */
  /* $BIU$12C$($kJ8;zJ,$rIU$12C$($?%a%b%j$N3NJ]@.8y(B */
  strcat(tmp,string);   /* NULL$BJ8;zNs$K(Bstring$B$rIU$12C$((B */
  strcat(tmp,sp->value);   /* $B$5$i$K(Bvalue$B$NIU$12C$((B */
  return tmp;
}
